/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.19.7
 *
 *     Copyright: (c) 2017 by Total Control Software
 *     License:   wxWindows License
 */

#include "sipAPI_propgrid.h"

        #include <wx/propgrid/propgrid.h>



PyDoc_STRVAR(doc_wxPGValidationInfo_GetFailureBehavior, "GetFailureBehavior() -> PGVFBFlags");

extern "C" {static PyObject *meth_wxPGValidationInfo_GetFailureBehavior(PyObject *, PyObject *);}
static PyObject *meth_wxPGValidationInfo_GetFailureBehavior(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
         ::wxPGValidationInfo *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxPGValidationInfo, &sipCpp))
        {
            unsigned char sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->GetFailureBehavior();
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return SIPBytes_FromStringAndSize((char *)&sipRes,1);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PGValidationInfo, sipName_GetFailureBehavior, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxPGValidationInfo_GetFailureMessage, "GetFailureMessage() -> String\n"
"\n"
"Returns current failure message.");

extern "C" {static PyObject *meth_wxPGValidationInfo_GetFailureMessage(PyObject *, PyObject *);}
static PyObject *meth_wxPGValidationInfo_GetFailureMessage(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const  ::wxPGValidationInfo *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxPGValidationInfo, &sipCpp))
        {
             ::wxString*sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = new  ::wxString(sipCpp->GetFailureMessage());
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PGValidationInfo, sipName_GetFailureMessage, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxPGValidationInfo_GetValue, "GetValue() -> PGVariant\n"
"\n"
"Returns reference to pending value.");

extern "C" {static PyObject *meth_wxPGValidationInfo_GetValue(PyObject *, PyObject *);}
static PyObject *meth_wxPGValidationInfo_GetValue(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
         ::wxPGValidationInfo *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxPGValidationInfo, &sipCpp))
        {
             ::wxPGVariant*sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = &sipCpp->GetValue();
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromType(sipRes,sipType_wxPGVariant,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PGValidationInfo, sipName_GetValue, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxPGValidationInfo_SetFailureBehavior, "SetFailureBehavior(failureBehavior)\n"
"\n"
"Set validation failure behaviour.");

extern "C" {static PyObject *meth_wxPGValidationInfo_SetFailureBehavior(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxPGValidationInfo_SetFailureBehavior(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        unsigned char failureBehavior;
         ::wxPGValidationInfo *sipCpp;

        static const char *sipKwdList[] = {
            sipName_failureBehavior,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "Bc", &sipSelf, sipType_wxPGValidationInfo, &sipCpp, &failureBehavior))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetFailureBehavior(failureBehavior);
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PGValidationInfo, sipName_SetFailureBehavior, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxPGValidationInfo_SetFailureMessage, "SetFailureMessage(message)\n"
"\n"
"Set current failure message.");

extern "C" {static PyObject *meth_wxPGValidationInfo_SetFailureMessage(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxPGValidationInfo_SetFailureMessage(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const  ::wxString* message;
        int messageState = 0;
         ::wxPGValidationInfo *sipCpp;

        static const char *sipKwdList[] = {
            sipName_message,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1", &sipSelf, sipType_wxPGValidationInfo, &sipCpp, sipType_wxString,&message, &messageState))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetFailureMessage(*message);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast< ::wxString *>(message),sipType_wxString,messageState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PGValidationInfo, sipName_SetFailureMessage, NULL);

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_wxPGValidationInfo(void *, int);}
static void release_wxPGValidationInfo(void *sipCppV, int)
{
    Py_BEGIN_ALLOW_THREADS

    delete reinterpret_cast< ::wxPGValidationInfo *>(sipCppV);

    Py_END_ALLOW_THREADS
}


extern "C" {static void assign_wxPGValidationInfo(void *, SIP_SSIZE_T, void *);}
static void assign_wxPGValidationInfo(void *sipDst, SIP_SSIZE_T sipDstIdx, void *sipSrc)
{
    reinterpret_cast< ::wxPGValidationInfo *>(sipDst)[sipDstIdx] = *reinterpret_cast< ::wxPGValidationInfo *>(sipSrc);
}


extern "C" {static void *array_wxPGValidationInfo(SIP_SSIZE_T);}
static void *array_wxPGValidationInfo(SIP_SSIZE_T sipNrElem)
{
    return new  ::wxPGValidationInfo[sipNrElem];
}


extern "C" {static void *copy_wxPGValidationInfo(const void *, SIP_SSIZE_T);}
static void *copy_wxPGValidationInfo(const void *sipSrc, SIP_SSIZE_T sipSrcIdx)
{
    return new  ::wxPGValidationInfo(reinterpret_cast<const  ::wxPGValidationInfo *>(sipSrc)[sipSrcIdx]);
}


extern "C" {static void dealloc_wxPGValidationInfo(sipSimpleWrapper *);}
static void dealloc_wxPGValidationInfo(sipSimpleWrapper *sipSelf)
{
    if (sipIsOwnedByPython(sipSelf))
    {
        release_wxPGValidationInfo(sipGetAddress(sipSelf), 0);
    }
}


extern "C" {static void *init_type_wxPGValidationInfo(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_wxPGValidationInfo(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
     ::wxPGValidationInfo *sipCpp = 0;

    {
        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, ""))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp = new  ::wxPGValidationInfo();
            Py_END_ALLOW_THREADS

            return sipCpp;
        }
    }

    {
        const  ::wxPGValidationInfo* a0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "J9", sipType_wxPGValidationInfo, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp = new  ::wxPGValidationInfo(*a0);
            Py_END_ALLOW_THREADS

            return sipCpp;
        }
    }

    return NULL;
}


static PyMethodDef methods_wxPGValidationInfo[] = {
    {SIP_MLNAME_CAST(sipName_GetFailureBehavior), meth_wxPGValidationInfo_GetFailureBehavior, METH_VARARGS, SIP_MLDOC_CAST(doc_wxPGValidationInfo_GetFailureBehavior)},
    {SIP_MLNAME_CAST(sipName_GetFailureMessage), meth_wxPGValidationInfo_GetFailureMessage, METH_VARARGS, SIP_MLDOC_CAST(doc_wxPGValidationInfo_GetFailureMessage)},
    {SIP_MLNAME_CAST(sipName_GetValue), meth_wxPGValidationInfo_GetValue, METH_VARARGS, SIP_MLDOC_CAST(doc_wxPGValidationInfo_GetValue)},
    {SIP_MLNAME_CAST(sipName_SetFailureBehavior), (PyCFunction)meth_wxPGValidationInfo_SetFailureBehavior, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxPGValidationInfo_SetFailureBehavior)},
    {SIP_MLNAME_CAST(sipName_SetFailureMessage), (PyCFunction)meth_wxPGValidationInfo_SetFailureMessage, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxPGValidationInfo_SetFailureMessage)}
};

sipVariableDef variables_wxPGValidationInfo[] = {
    {PropertyVariable, sipName_Value, &methods_wxPGValidationInfo[2], NULL, NULL, NULL},
    {PropertyVariable, sipName_FailureMessage, &methods_wxPGValidationInfo[1], &methods_wxPGValidationInfo[4], NULL, NULL},
    {PropertyVariable, sipName_FailureBehavior, &methods_wxPGValidationInfo[0], &methods_wxPGValidationInfo[3], NULL, NULL},
};

PyDoc_STRVAR(doc_wxPGValidationInfo, "Used to convey validation information to and from functions that\n"
"actually perform validation.");


sipClassTypeDef sipTypeDef__propgrid_wxPGValidationInfo = {
    {
        -1,
        0,
        0,
        SIP_TYPE_CLASS,
        sipNameNr_wxPGValidationInfo,
        {0},
        0
    },
    {
        sipNameNr_PGValidationInfo,
        {0, 0, 1},
        5, methods_wxPGValidationInfo,
        0, 0,
        3, variables_wxPGValidationInfo,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    doc_wxPGValidationInfo,
    -1,
    -1,
    0,
    0,
    init_type_wxPGValidationInfo,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_wxPGValidationInfo,
    assign_wxPGValidationInfo,
    array_wxPGValidationInfo,
    copy_wxPGValidationInfo,
    release_wxPGValidationInfo,
    0,
    0,
    0,
    0,
    0,
    0,
    0
};
